/***
This is simple code to establisch a communication between arduino and RFID reader

The code will scan for EPC tags and display the EPC in the LCD

The RFID Reader is connected to the Tx & Rx pins (Pin1 & Pin0) of Arduino Duemilanove

***/

#include <SoftwareSerial.h>

byte LCDrx = 7;
byte LCDtx = 8;
SoftwareSerial LCD = SoftwareSerial(LCDrx, LCDtx);

byte cmdscan[] = {0x52, 0x46, 0x45, 0x01, 0x50, 0x01, 0x02, 0x00, 0x04, 0x07}; //command to start scan. The last byte is the checksum, it is different for other commands


int dataCount = 0;
int dataLength = 0;
String RFIDdatahex[40];
String LCDdata;
char data;
String datahex = "";
int epcstart = 15;
int epcend = 27;


  
void setup() {
  pinMode(13,OUTPUT);
  pinMode(LCDrx,INPUT);
  pinMode(LCDtx,OUTPUT);
  Serial.begin(115200); //Baudrate for RFID reader
  LCD.begin(9600);  //Baudrate for LCD
  
  LCD.print("sc;");
  LCD.print("sd0,0;");
  LCD.print("ssCommand Sent;");    
  
}




void loop()
{  
  Serial.write(cmdscan, sizeof(cmdscan));//Send command to the Reader
  //Get the reply from the Reader
  while (Serial.available() > 0) {
    dataLength = readSerial();
  }
  //Display the output on LCD
  if(dataLength > 0) {
    Serial.flush();
    displayData(dataLength);
    dataLength = 0;    
  }
  delay(1000);

} 

//Function to read the reply from Reader
int readSerial() {
  while (Serial.available()>0) {
    digitalWrite(13,HIGH);    
    data = Serial.read();    
    datahex = String(data, HEX);    
    if (datahex.length() == 4) {        
      datahex.replace("ff",""); 
    }
    else if (datahex.length() == 1) {
      datahex = "0"+datahex;
    }    
    RFIDdatahex[dataCount] = datahex;
    dataCount = dataCount+1;
    
  }
  Serial.flush();
  return dataCount;
}

//Analyze the reply from reader and send it to LCD
void displayData(int Length) { 
    dataCount = 0;    
    LCD.print("sc;");
    LCD.print("sd0,0;");
    LCD.println("ssEPC-;");       
    if (Length < 15) {
      LCD.println("ssNo Tag"); 
    }    
    else {      
      for (int j=epcstart; j<epcend; j++) {
        dataCount = dataCount + 1;
        LCDdata = RFIDdatahex[j];
        Serial.print(LCDdata);
        LCD.println("ss"+LCDdata+";");
      
        if (dataCount == 6) {
          LCD.println("sd1,0;");
        }
      
      }
    }
    digitalWrite(13, LOW);
    Serial.println();
    dataCount = 0;
    
}   

